package org.javacodegeeks.examples;

import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Random;
import java.util.stream.Collectors;
import java.util.stream.IntStream;

public class BaseExampleMain {
    public static void main(String[] args) {
        // Generate names
        Random r = new Random();
        var names = List.of("Joe", "Monica", "Chandler", "Phoebe", "Rachel", "Ross", "Janice");
        var namesList = IntStream.range(0, 1000000)
            .mapToObj(__ -> names.get(r.nextInt(names.size())))
            .collect(Collectors.toList());

        // Aggregate counts
        Map<String, Long> counts = new HashMap<>();
        for (String name : namesList) {
            counts.compute(name, (n, c) -> c == null ? 1L : c + 1);
        }

        // Find the max count
        String mostFrequentName = counts.entrySet()
            .stream()
            .max(Map.Entry.comparingByValue())
            .get()
            .getKey();

        System.out.printf("The most frequent name is %s%n", mostFrequentName);
    }
}